image: docker:stable

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2

services:
  - docker:dind

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

stages:
  - test
  - build
  - deploy

test:
  stage: test
  script:
    - docker build -f phpunit.Dockerfile -t hello-world-test .
    - docker run hello-world-test
  only:
    - merge_requests
    - tags

build:
  stage: build
  script:
    - docker build -t $CI_REGISTRY_IMAGE:$CI_BUILD_TAG .
    - docker push $CI_REGISTRY_IMAGE:$CI_BUILD_TAG
  only:
    - tags

deploy:
  stage: deploy
  script:
    - echo "deploying now"
  only:
    - tags
